Kefa and Dishes CodeForces - 580D (dp 状态压缩)

When Kefa came to the restaurant and sat at a table, the waiter immediately brought him the menu. There were n dishes. Kefa knows that he needs exactly m dishes. But at that, he doesn't want to order the same dish twice to taste as many dishes as possible.

Kefa knows that the i-th dish gives him ai units of satisfaction. But some dishes do not go well together and some dishes go very well together. Kefa set to himself krules of eating food of the following type — if he eats dish x exactly before dishy (there should be no other dishes between x and y), then his satisfaction level raises by c.

Of course, our parrot wants to get some maximal possible satisfaction from going to the restaurant. Help him in this hard task!

Input

The first line of the input contains three space-separated numbers, nm and k (1 ≤ m ≤ n ≤ 180 ≤ k ≤ n * (n - 1)) — the number of dishes on the menu, the number of portions Kefa needs to eat to get full and the number of eating rules.

The second line contains n space-separated numbers ai, (0 ≤ ai ≤ 109) — the satisfaction he gets from the i-th dish.

Next k lines contain the rules. The i-th rule is described by the three numbers xi,yi and ci (1 ≤ xi, yi ≤ n0 ≤ ci ≤ 109). That means that if you eat dish xi right before dish yi, then the Kefa's satisfaction increases by ci. It is guaranteed that there are no such pairs of indexes i and j (1 ≤ i < j ≤ k), that xi = xj and yi = yj.

Output

In the single line of the output print the maximum satisfaction that Kefa can get from going to the restaurant.

Example
Input
2 2 1
1 1
2 1 1
Output
3
Input
4 3 2
1 2 3 4
2 1 5
3 4 2
Output
12
Note

In the first sample it is best to first eat the second dish, then the first one. Then we get one unit of satisfaction for each dish and plus one more for the rule.

In the second test the fitting sequences of choice are 4 2 1 or 2 1 4. In both cases we get satisfaction 7 for dishes and also, if we fulfill rule 1, we get an additional satisfaction 5.


题意 :有n道菜,每道有它的 dishs,现在挑选 m 道不同的菜,有k组介绍说x菜再y的前面吃增加c dishs

求最大dishes。


思路 : 如果不管吃菜顺序带来的加成效果,那么最多18道菜每道菜吃或者不吃两种情况,那么最多有

2^18种可能,因为一个整数有32位,如果取前18位代表18个菜,0,1,代表不吃或吃,那么就实现了一个整数代表一个状态,也就是状态压缩。这些状态有什么关系呢?考虑最简单的状态s = 1;那么s下最后吃的一道菜一定是第一道菜,因为他就一道,所以如果添加一道的话,s=1将会更新(s|2^i)的值(i>=0&&i<18)

所以,这样就实现了由小状态更新大状态的关系。如果s中有多道菜,只要扫一遍,让每个菜作为最后吃的然后在去用没加入的菜更新(s|2^i)。


#include 
#include 
#include 
#include 
#include 
#include 
#include 
using namespace std;
typedef long long ll;

int v[20];
int mp[20][20];
ll dp[(1<<18)+5][20];

int main()
{
    ll n,m,k;
    cin >> n >> m >> k;
    for(int i = 0; i < n; i++)
    {
         cin >>v[i];
    }
    for(int j = 0; j < k; j++)
    {
        int x,y,z;
        cin >> x >> y >> z;
        mp[x-1][y-1] = z;
    }
    for(int i = 0; i < n; i++)
    {
        dp[1<


你可能感兴趣的:(dp)